from typing import Any
from weakref import WeakSet

__version__: str

class CBHandle:
    def cancel(self): ...
    def cancelled(self) -> bool: ...

class TimerHandle:
    when: int

    def cancel(self): ...
    def cancelled(self) -> bool: ...

class EventLoop:
    _asyncgens: WeakSet
    _asyncgens_shutdown_called: bool
    _base_ctx: Any
    _clock: int
    _closed: bool
    _default_executor: Any
    _executor_shutdown_called: bool
    _exc_handler: Any
    _exception_handler: Any
    _sig_listening: bool
    _sig_loop_handled: bool
    _sig_wfd: Any
    _signals: set
    _ssock_r: Any
    _ssock_w: Any
    _stopping: bool
    _task_factory: Any
    _thread_id: int
    _watcher_child: Any

    def _run(self): ...
    def _wake(self): ...
    def _call_soon(self, callback, args, context) -> CBHandle: ...
    def _call_later(self, delay, callback, args, context) -> TimerHandle: ...
    def _reader_add(self, fd, callback, args, context) -> CBHandle: ...
    def _reader_rem(self, fd) -> bool: ...
    def _writer_add(self, fd, callback, args, context) -> CBHandle: ...
    def _writer_rem(self, fd) -> bool: ...
    def _sig_add(self, sig, callback, context): ...
    def _sig_rem(self, sig) -> bool: ...
    def _sig_clear(self): ...
    def _sig_handle(self, sig) -> bool: ...
    def _sig_ceval(self, noop: Any): ...
    def _ssock_set(self, fd): ...
    def _ssock_del(self, fd): ...
